Attribute VB_Name = "BasCasio"
'***** Global variables ****************************
 Global gStrTabela          As String    '*** Usada na funcao FU_PEGAFORMULA
 Global gStrFormula         As String    '*** Usada na funcao FU_PEGAFORMULA
 Global gSistema            As String    '*** Nome do Sistema e verso
 Global gSair               As Boolean   '*** Usada para verificao do Sair da tela de Sair
 Global gSQL                As String    '*** Select enviado para a grid
 Global gStoredProcedure    As String    '*** SP enviado para a grid
 Global gRetorno            As String    '*** Retorno da Grid
 Global gCamposRetorno      As String
 Global gCampoCodigo        As String
 Global gCampoCodigoRetorno As String
 Global gVersao             As String
 Global gConexaoCliente     As rdoConnection
 Global gColunasInvisiveis  As String
 
 Global gXCampoRetorno01 As String: Global gXCampoResultado01 As String
 Global gXCampoRetorno02 As String: Global gXCampoResultado02 As String
 Global gXCampoRetorno03 As String: Global gXCampoResultado03 As String
 Global gXCampoRetorno04 As String: Global gXCampoResultado04 As String
 Global gXCampoRetorno05 As String: Global gXCampoResultado05 As String
 Global gXCampoRetorno06 As String: Global gXCampoResultado06 As String
 Global gXCampoRetorno07 As String: Global gXCampoResultado07 As String
 Global gXCampoRetorno08 As String: Global gXCampoResultado08 As String
 Global gXCampoRetorno09 As String: Global gXCampoResultado09 As String
 Global gXCampoRetorno10 As String: Global gXCampoResultado10 As String


'**********************************************************************
'* Funo......: FU_SoLetras ( a )
'* Descrio...: Funo para validao de um textbox, maskedit, etc
'* Parmetros..: a -> Keyascii vindo do texto box
'* Retorno.....: Mesmo Keyascii se passar no filtro
'* Obs.........:
'* Exemplo.....: keyascii = FU_SoLetras(keyascii)
'**********************************************************************
Function FU_SoLetras(iKeyascii As Integer) As Integer
      
      Dim lstrLetras As String
      lstrLetras = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvxyz0123456789-=.` " & Chr(8)
      
      If InStr(1, lstrLetras, Chr(iKeyascii)) > 0 Then
         FU_SoLetras = iKeyascii
      End If

End Function
'**********************************************************************
'* Funo......: FU_SoNumeros ( a )
'* Descrio...: Funo para validao de um textbox, maskedit, etc
'* Parmetros..: a -> Keyascii vindo do texto box
'* Retorno.....: Mesmo Keyascii se passar no filtro
'* Obs.........:
'* Exemplo.....: keyascii = FU_SoNumeros(keyascii)
'**********************************************************************
Function FU_SoNumeros(iKeyascii As Integer) As Integer

      Dim lstrNumeros As String
      lstrNumeros = "0123456789" & Chr(8)
      
      If InStr(1, lstrNumeros, Chr(iKeyascii)) > 0 Then
         FU_SoNumeros = iKeyascii
      End If
      
End Function
'**********************************************************************
'* Funo......: FU_SoNumerosDec ( a )
'* Descrio...: Funo para validao de um textbox, maskedit, etc
'* Parmetros..: a -> Keyascii vindo do texto box
'* Retorno.....: Mesmo Keyascii se passar no filtro
'* Obs.........:
'* Exemplo.....: keyascii = FU_SoNumerosDec(keyascii)
'**********************************************************************
Function FU_SoNumerosDec(iKeyascii As Integer) As Integer
      
      Dim lstrNumeros As String
      lstrNumeros = "0123456789,."
      If InStr(1, lstrNumeros, Chr(iKeyascii)) > 0 Then
         FU_SoNumerosDec = iKeyascii
      End If

End Function
'***********************************************************************
'* Funo....:   FU_TrocaAspasSimples (  A  )
'* Parmetros:   A  ->  String onde a funo ir procurar a aspa simples
'* Retorno...:   A mesma string s que com a aspa simples trocada para `
'*
'* Exemplos..:   Nome = FU_TrocaAspasSimples(Nome)
'*               X  = FU_TrocaAspasSimples("Claudio D'gua")
'***********************************************************************
Function FU_TrocaAspasSimples(strNome As String) As String

        Dim strRetorno As String
        strRetorno = strNome
        
        Do While InStr(strRetorno, "'") <> 0
           Mid(strRetorno, InStr(strRetorno, "'"), 1) = "`"
        Loop

        FU_TrocaAspasSimples = strRetorno
        
End Function
'***********************************************************************
'* Funo....:   FU_VirgulaPonto (  A  )
'* Parmetros:   A  ->  String onde estar o nmero com virgulas
'* Retorno...:   A mesma string s que formatada sem as virgulas para
'*               gravao no Banco
'* Exemplos..:   ? FU_VirgulaPonto("123.555.555,66")
'***********************************************************************
Function FU_VirgulaPonto(strCampo As String)
         
         Dim la           As Integer
         Dim lstrRetorno  As String
         Dim liQtdeCarac  As Integer
         
         lstrRetorno = ""
         For la = 1 To Len(strCampo)
             If Not IsNumeric(Mid(strCampo, la, 1)) Then
                liQtdeCarac = liQtdeCarac + 1
             End If
         Next
         
         For la = 1 To Len(strCampo)
             If Mid(strCampo, la, 1) = "," Then
                lstrRetorno = lstrRetorno & "."
             Else
                lstrRetorno = lstrRetorno & Mid(strCampo, la, 1)
             End If
         Next
         
         If Val(lstrRetorno) = 0 Or liQtdeCarac > 1 Then
            lstrRetorno = "0"
         End If
         
         FU_VirgulaPonto = lstrRetorno
         
End Function
'**********************************************************************
'* Funo......: FU_TrocaCaracter ( a, b, c )
'* Descrio...: Funo para troca de letras de uma varivel
'* Parmetros..: a -> String a ser convertida
'*               b -> Letra/string a procurar
'*               c -> Letra/string para troca
'* Retorno.....: Mesma string, s que j trocada
'* Obs.........:
'* Exemplo.....: strTexto = FU_TrocaCaracter(strTexto,".",",")
'**********************************************************************
Function FU_TrocaCaracter(strTexto, strAntes As String, strDepois As String) As String

         Do While InStr(strTexto, strAntes) > 0
            Mid(strTexto, InStr(strTexto, strAntes), Len(strAntes)) = strDepois
         Loop
          
         FU_TrocaCaracter = strTexto
         
End Function
'***************************************************************************
'* Funo......: FU_SoMaiuscula ( a )
'* Descrio...: Funo para retornar o codigo ASCII ja transformado para maiscula
'* Parmetros..: a -> Keyascii que vem de um textbox, grid, etc
'* Retorno.....: Mesmo keyascii s que j convertido
'* Obs.........:
'* Exemplo.....:  Keyascii = FU_SoMaiuscula(Keyascii)
'***************************************************************************
Function FU_SoMaiuscula(KeyAscii As Integer)
    
    FU_SoMaiuscula = Asc(UCase(Chr(KeyAscii)))

End Function
'***************************************************************************
'* Funo......: FU_SoMinuscula ( a )
'* Descrio...: Funo para retornar o codigo ASCII ja transformado para minscula
'* Parmetros..: a -> Keyascii que vem de um textbox, grid, etc
'* Retorno.....: Mesmo keyascii s que j convertido
'* Obs.........:
'* Exemplo.....:  Keyascii = FU_SoMinuscula(Keyascii)
'***************************************************************************
Function FU_SoMinuscula(KeyAscii As Integer)
    
    FU_SoMinuscula = Asc(LCase(Chr(KeyAscii)))

End Function
'****************************************************************
'* Funo......: FU_PegaFormula ( a )
'* Descrio...: Funo para pegar a formula para filtro de tabelas
'* Parmetros..: a -> Tabela a ser pega
'* Retorno.....: string contendo a formula para filtro
'* Obs.........:
'* Exemplo.....: ? FU_PegaFormula("tb_RH_Funcionarios")
'****************************************************************'
Function FU_PegaFormula(strTabela As String) As String
 
         gStrTabela = strTabela
         frm_Filtro.lbl_Tabela = strTabela
         frm_Filtro.Show 1
         FU_PegaFormula = gStrFormula

End Function
Function FU_PegaTabelaSelect(strSQL As String) As String
         
         Dim iInicio As Integer
         Dim iFim    As Integer
         Dim strSub  As String
         strSQL = strSQL + " "
         iInicio = InStr(UCase(strSQL), "FROM") + 5
         strSub = Mid(strSQL, iInicio, Len(strSQL) - iInicio)
         strSub = Trim(strSub) + " "
         
         iFim = InStr(UCase(strSub), " ")
         FU_PegaTabelaSelect = Trim(Mid(strSub, 1, iFim))
         
End Function
Function FU_PegaCamposSelect(strSQL As String) As String
         
         Dim iInicio As Integer
         Dim iFim    As Integer
         
         If Trim(strSQL) = "" Then
            FU_PegaCamposSelect = ""
            Exit Function
         End If
         
         iInicio = InStr(UCase(strSQL), "SELECT") + 7
         iFim = InStr(UCase(strSQL), "FROM")

         FU_PegaCamposSelect = Trim(Mid(strSQL, 8, iFim - iInicio))
 
End Function
Sub SU_RetornaGrid()
          
          Dim a As Integer

           a = 0
           On Error GoTo SaiDoLoop1
           Do
              If UCase(gCamposRetorno) = UCase(frm_Grid.grd_Selecao.Columns(a).Caption) Then
                 frm_Grid.grd_Selecao.Col = a
                 gRetorno = Trim(frm_Grid.grd_Selecao.Text)
                 GoTo SaiDoLoop1
              End If
              a = a + 1
           Loop

SaiDoLoop1:
           On Error GoTo 0
           
           gRetorno = Trim(frm_Grid.grd_Selecao.Text)
           
           If Trim(gCampoCodigo) <> "" Then
              
              gCampoCodigoRetorno = ""
              a = 0
              On Error GoTo SaiDoLoop2
              
              Do
                 If UCase(gCampoCodigo) = UCase(frm_Grid.grd_Selecao.Columns(a).Caption) Then
                    frm_Grid.grd_Selecao.Col = a
                    gCampoCodigoRetorno = Trim(frm_Grid.grd_Selecao.Text)
                    GoTo SaiDoLoop2
                 End If
                 a = a + 1
                 If a > frm_Grid.grd_Selecao.Columns.Count - 1 Then GoTo SaiDoLoop2
              Loop
SaiDoLoop2:
              On Error GoTo 0
           End If
           
          '########################################################################
           If Trim(gXCampoRetorno01) <> "" Then
              gXCampoResultado01 = ""
              For a = 0 To frm_Grid.rdc_selecao.Resultset.rdoColumns.Count - 1
                  If UCase(gXCampoRetorno01) = UCase(Trim(frm_Grid.rdc_selecao.Resultset.rdoColumns(a).Name)) Then
                     gXCampoResultado01 = "" & frm_Grid.rdc_selecao.Resultset(a)
                     Exit For
                  End If
              Next
           End If
          '------------------------------------------------------------------------
           If Trim(gXCampoRetorno02) <> "" Then
              gXCampoResultado02 = ""
              For a = 0 To frm_Grid.rdc_selecao.Resultset.rdoColumns.Count - 1
                  If UCase(gXCampoRetorno02) = UCase(Trim(frm_Grid.rdc_selecao.Resultset.rdoColumns(a).Name)) Then
                     gXCampoResultado02 = "" & frm_Grid.rdc_selecao.Resultset(a)
                     Exit For
                  End If
              Next
           End If
          '------------------------------------------------------------------------
           If Trim(gXCampoRetorno03) <> "" Then
              gXCampoResultado03 = ""
              For a = 0 To frm_Grid.rdc_selecao.Resultset.rdoColumns.Count - 1
                  If UCase(gXCampoRetorno03) = UCase(Trim(frm_Grid.rdc_selecao.Resultset.rdoColumns(a).Name)) Then
                     gXCampoResultado03 = "" & frm_Grid.rdc_selecao.Resultset(a)
                     Exit For
                  End If
              Next
           End If
          '------------------------------------------------------------------------
           If Trim(gXCampoRetorno04) <> "" Then
              gXCampoResultado04 = ""
              For a = 0 To frm_Grid.rdc_selecao.Resultset.rdoColumns.Count - 1
                  If UCase(gXCampoRetorno04) = UCase(Trim(frm_Grid.rdc_selecao.Resultset.rdoColumns(a).Name)) Then
                     gXCampoResultado04 = "" & frm_Grid.rdc_selecao.Resultset(a)
                     Exit For
                  End If
              Next
           End If
          '------------------------------------------------------------------------
           If Trim(gXCampoRetorno05) <> "" Then
              gXCampoResultado05 = ""
              For a = 0 To frm_Grid.rdc_selecao.Resultset.rdoColumns.Count - 1
                  If UCase(gXCampoRetorno05) = UCase(Trim(frm_Grid.rdc_selecao.Resultset.rdoColumns(a).Name)) Then
                     gXCampoResultado05 = "" & frm_Grid.rdc_selecao.Resultset(a)
                     Exit For
                  End If
              Next
           End If
          '------------------------------------------------------------------------
           If Trim(gXCampoRetorno06) <> "" Then
              gXCampoResultado06 = ""
              For a = 0 To frm_Grid.rdc_selecao.Resultset.rdoColumns.Count - 1
                  If UCase(gXCampoRetorno06) = UCase(Trim(frm_Grid.rdc_selecao.Resultset.rdoColumns(a).Name)) Then
                     gXCampoResultado06 = "" & frm_Grid.rdc_selecao.Resultset(a)
                     Exit For
                  End If
              Next
           End If
          '------------------------------------------------------------------------
           If Trim(gXCampoRetorno07) <> "" Then
              gXCampoResultado07 = ""
              For a = 0 To frm_Grid.rdc_selecao.Resultset.rdoColumns.Count - 1
                  If UCase(gXCampoRetorno07) = UCase(Trim(frm_Grid.rdc_selecao.Resultset.rdoColumns(a).Name)) Then
                     gXCampoResultado07 = "" & frm_Grid.rdc_selecao.Resultset(a)
                     Exit For
                  End If
              Next
           End If
          '------------------------------------------------------------------------
           If Trim(gXCampoRetorno08) <> "" Then
              gXCampoResultado08 = ""
              For a = 0 To frm_Grid.rdc_selecao.Resultset.rdoColumns.Count - 1
                  If UCase(gXCampoRetorno08) = UCase(Trim(frm_Grid.rdc_selecao.Resultset.rdoColumns(a).Name)) Then
                     gXCampoResultado08 = "" & frm_Grid.rdc_selecao.Resultset(a)
                     Exit For
                  End If
              Next
           End If
          '------------------------------------------------------------------------
           If Trim(gXCampoRetorno09) <> "" Then
              gXCampoResultado09 = ""
              For a = 0 To frm_Grid.rdc_selecao.Resultset.rdoColumns.Count - 1
                  If UCase(gXCampoRetorno09) = UCase(Trim(frm_Grid.rdc_selecao.Resultset.rdoColumns(a).Name)) Then
                     gXCampoResultado09 = "" & frm_Grid.rdc_selecao.Resultset(a)
                     Exit For
                  End If
              Next
           End If
          '------------------------------------------------------------------------
           If Trim(gXCampoRetorno10) <> "" Then
              gXCampoResultado10 = ""
              For a = 0 To frm_Grid.rdc_selecao.Resultset.rdoColumns.Count - 1
                  If UCase(gXCampoRetorno10) = UCase(Trim(frm_Grid.rdc_selecao.Resultset.rdoColumns(a).Name)) Then
                     gXCampoResultado10 = "" & frm_Grid.rdc_selecao.Resultset(a)
                     Exit For
                  End If
              Next
           End If
          '########################################################################
           
           Unload frm_Grid
           
End Sub

Function FU_RetiraEspacos(strComEspacos As String) As String

        Dim strRetorno As String
        Dim x As Integer
        
        strRetorno = ""
        
        For x = 1 To Len(strComEspacos)
            If Mid(strComEspacos, x, 1) <> " " Then
               strRetorno = strRetorno & Mid(strComEspacos, x, 1)
            End If
        Next
        
        FU_RetiraEspacos = strRetorno
        
End Function
Function FU_PegaAteTraco(strTexto As String) As String
         
         Dim iPos As Integer
         
         If InStr(strTexto, " - ") > 0 Then
            On Error Resume Next
            FU_PegaAteTraco = Left(strTexto, InStr(strTexto, " - ") - 1)
            If Err <> 0 Then FU_PegaAteTraco = ""
            On Error GoTo 0
         Else
            FU_PegaAteTraco = strTexto
         End If
         
         
End Function
