VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.UserControl CasioQV 
   ClientHeight    =   1140
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3075
   InvisibleAtRuntime=   -1  'True
   ScaleHeight     =   1140
   ScaleWidth      =   3075
   ToolboxBitmap   =   "CasioQV.ctx":0000
   Begin MSCommLib.MSComm Comm1 
      Left            =   2430
      Top             =   510
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   327681
      DTREnable       =   -1  'True
   End
   Begin VB.Image imgCasio 
      Height          =   570
      Left            =   0
      Picture         =   "CasioQV.ctx":0312
      Top             =   0
      Width           =   570
   End
End
Attribute VB_Name = "CasioQV"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True

Enum QuaisPortas
     Com1 = 1
     Com2 = 2
     Com3 = 3
     Com4 = 4
     Com5 = 5
     Com6 = 6
     Com7 = 7
     Com8 = 8
End Enum

'Event EntraNoFiltro()
'Event SaiDoFiltro(strRetorno As Variant)

Const m_def_Porta = Com1: Dim m_Porta As QuaisPortas
Const m_def_TimeOut = 10: Dim m_TimeOut As Integer

Private Sub UserControl_Resize()
        
        On Error Resume Next
        UserControl.Width = imgCasio.Width
        UserControl.Height = imgCasio.Height
        On Error GoTo 0
        
End Sub
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Habilita ou no o CasioQV"
    Enabled = UserControl.Enabled
End Property
Public Property Let Enabled(ByVal New_Enabled As Boolean)
    UserControl.Enabled = New_Enabled
    PropertyChanged "Enabled"
End Property
Private Sub UserControl_InitProperties()

    m_Porta = m_def_Porta
    m_TimeOut = m_def_TimeOut

End Sub
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    m_Porta = PropBag.ReadProperty("Porta", m_def_Porta)
    m_TimeOut = PropBag.ReadProperty("TimeOut", m_def_TimeOut)
    
End Sub
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("Enabled", UserControl.Enabled, True)
    Call PropBag.WriteProperty("Porta", m_Porta, m_def_Porta)
    Call PropBag.WriteProperty("TimeOut", m_TimeOut, m_def_TimeOut)
    
End Sub
Public Property Get TimeOut() As Integer
       TimeOut = m_TimeOut
End Property
Public Property Let TimeOut(ByVal New_TimeOut As Integer)
    m_TimeOut = New_TimeOut
    PropertyChanged "TimeOut"
End Property
Public Property Get Porta() As QuaisPortas
       Porta = m_Porta
End Property
Public Property Let Porta(ByVal New_Porta As QuaisPortas)
Attribute Porta.VB_Description = "N da Porta onde ser ligada a cmera"
    m_Porta = New_Porta
    Comm1.CommPort = New_Porta
    PropertyChanged "Porta"
End Property
'****************************************************************
'*  Funo....:  TotalFotos
'*  Descricao.:  Retorna o total de Fotos armazenadas na camera
'*  Parmetros:  nenhum
'*  Retorno...:  Inteiro com o nmero armazenados ou codigo de
'*               erro negativo
'*               -1 = Saiu por TimeOut
'*               -2 = Porta no Abriu
'*               -3 = Porta no fechou
'*               -4 = Porta j est aberta
'****************************************************************
Public Function TotalFotos() As Integer

    Dim iRetorno As Integer
    Dim Instring As String
    Dim t1, t2
    
    On Error Resume Next
    Comm1.CommPort = Porta
    If Err <> 0 Then iRetorno = -4: GoTo fimfuncao
    On Error GoTo 0
    
    Comm1.Settings = "9600,N,8,1"
    Comm1.InputLen = 0
    Comm1.InBufferSize = 10
    
    On Error Resume Next
    Comm1.PortOpen = True
    If Err <> 0 Then iRetorno = -2: GoTo fimfuncao
    On Error GoTo 0
    
    Comm1.Output = Chr(5) & "MP" & Chr(6) & Chr(6)
    Instring = ""
    
    t1 = Now
    t2 = DateAdd("s", TimeOut, t1)
    iRetorno = 0
    
    Do
         DoEvents
         If Now >= t2 Then
            iRetorno = -1
            Exit Do
         End If
         
    Loop Until Comm1.InBufferCount >= 3
    
    Instring = Instring & Comm1.Input
    
    On Error Resume Next
    Comm1.PortOpen = False
    If Err <> 0 Then iRetorno = -3: GoTo fimfuncao
    On Error GoTo 0
    
    If iRetorno = -1 Then GoTo fimfuncao
    
    If Trim(Instring) = "" Then
       iRetorno = 0
    Else
       iRetorno = Asc(Right(Instring, 1))
    End If
    
fimfuncao:
    
    TotalFotos = iRetorno
    
End Function
'****************************************************************
'*  Funo....:  Bateria
'*  Descricao.:  Retorna o total de Bateria restante na camera
'*  Parmetros:  nenhum
'*  Retorno...:  Inteiro com o nmero armazenados ou codigo de
'*               erro negativo
'*               -1 = Saiu por TimeOut
'*               -2 = Porta no Abriu
'*               -3 = Porta no fechou
'*               -4 = Porta j est aberta
'****************************************************************
Public Function Bateria() As Integer

    Dim iRetorno As Integer
    Dim Instring As String
    Dim t1, t2
    
    On Error Resume Next
    Comm1.CommPort = Porta
    If Err <> 0 Then iRetorno = -4: GoTo fimfuncao
    On Error GoTo 0
    
    Comm1.Settings = "9600,N,8,1"
    Comm1.InputLen = 0
    Comm1.InBufferSize = 10
    
    On Error Resume Next
    Comm1.PortOpen = True
    If Err <> 0 Then iRetorno = -2: GoTo fimfuncao
    On Error GoTo 0
    
    Comm1.Output = Chr(5) & "RB" & Chr(5) & Chr(255) & Chr(254) & Chr(230) & Chr(6)
    Instring = ""
    
    t1 = Now
    t2 = DateAdd("s", TimeOut, t1)
    iRetorno = 0
    
    Do
         DoEvents
         If Now >= t2 Then
            iRetorno = -1
            Exit Do
         End If
         
    Loop Until Comm1.InBufferCount >= 3
    
    Instring = Instring & Comm1.Input
    
    On Error Resume Next
    Comm1.PortOpen = False
    If Err <> 0 Then iRetorno = -3: GoTo fimfuncao
    On Error GoTo 0
    
    If iRetorno = -1 Then GoTo fimfuncao
    
    If Trim(Instring) = "" Then
       iRetorno = 0
    Else
       iRetorno = Asc(Right(Instring, 1)) / 16
    End If
    
fimfuncao:
    
    Bateria = iRetorno
    
End Function
'****************************************************************
'*  Funo....:  Desliga
'*  Descricao.:  Desliga a cmera
'*  Parmetros:  nenhum
'*  Retorno...:  0 caso der certo ou ou codigo de erro negativo
'*              -1 = Saiu por TimeOut
'*              -2 = Porta no Abriu
'*              -3 = Porta no fechou
'*              -4 = Porta j est aberta
'*              -5 = No retornou o 86, checksum
'****************************************************************
Public Function Desliga() As Integer

    Dim iRetorno As Integer
    Dim Instring As String
    Dim t1, t2
    
    On Error Resume Next
    Comm1.CommPort = Porta
    If Err <> 0 Then iRetorno = -4: GoTo fimfuncao
    On Error GoTo 0
    
    Comm1.Settings = "9600,N,8,1"
    Comm1.InputLen = 0
    Comm1.InBufferSize = 10
    
    On Error Resume Next
    Comm1.PortOpen = True
    If Err <> 0 Then iRetorno = -2: GoTo fimfuncao
    On Error GoTo 0
    '/fu_envia (Chr(5) & "QX" & Chr(6) & Chr(6) & Chr(56)
    Comm1.Output = Chr(5) & "QX" & Chr(6) & Chr(6) & Chr(56)
    Instring = ""
    
    t1 = Now
    t2 = DateAdd("s", TimeOut, t1)
    iRetorno = 0
    
    Do
         DoEvents
         If Now >= t2 Then
            iRetorno = -1
            Exit Do
         End If
         
    Loop Until Comm1.InBufferCount >= 2
    
    Instring = Instring & Comm1.Input
    
    On Error Resume Next
    Comm1.PortOpen = False
    If Err <> 0 Then iRetorno = -3: GoTo fimfuncao
    On Error GoTo 0
    
    If iRetorno = -1 Then GoTo fimfuncao
    
    If Trim(Instring) = "" Then
       iRetorno = -5
    Else
       iRetorno = Asc(Right(Instring, 1))
       If iRetorno = 86 Then
          iRetorno = 0
       Else
          iRetorno = -5
       End If
    End If
    
fimfuncao:
    
    Desliga = iRetorno
    
End Function
'****************************************************************
'*  Funo....:  Reset
'*  Descricao.:  Reseta a camera
'*  Parmetros:  nenhum
'*  Retorno...:  0 caso der certo ou ou codigo de erro negativo
'*               -1 = Saiu por TimeOut
'*               -2 = Porta no Abriu
'*               -3 = Porta no fechou
'*               -4 = Porta j est aberta
'*               -5 = No retornou o 92, checksum
'****************************************************************
Public Function Reset() As Integer

    Dim iRetorno As Integer
    Dim Instring As String
    Dim t1, t2
    
    On Error Resume Next
    Comm1.CommPort = Porta
    If Err <> 0 Then iRetorno = -4: GoTo fimfuncao
    On Error GoTo 0
    
    Comm1.Settings = "9600,N,8,1"
    Comm1.InputLen = 0
    Comm1.InBufferSize = 10
    
    On Error Resume Next
    Comm1.PortOpen = True
    If Err <> 0 Then iRetorno = -2: GoTo fimfuncao
    On Error GoTo 0
    
    Comm1.Output = Chr(5) & "QR" & Chr(6) & Chr(6)
    Instring = ""
    
    t1 = Now
    t2 = DateAdd("s", TimeOut, t1)
    iRetorno = 0
    
    Do
         DoEvents
         If Now >= t2 Then
            iRetorno = -1
            Exit Do
         End If
         
    Loop Until Comm1.InBufferCount >= 1
    
    Instring = Instring & Comm1.Input
    
    On Error Resume Next
    Comm1.PortOpen = False
    If Err <> 0 Then iRetorno = -3: GoTo fimfuncao
    On Error GoTo 0
    
    If iRetorno = -1 Then GoTo fimfuncao
    
    If Trim(Instring) = "" Then
       iRetorno = -5
    Else
       iRetorno = Asc(Right(Instring, 1))
       If iRetorno = 92 Then
          iRetorno = 0
       Else
          iRetorno = -5
       End If
    End If
    
fimfuncao:
    
    Reset = iRetorno
    
End Function
'****************************************************************
'*  Funo....:  Reset2
'*  Descricao.:  Reseta a camera
'*  Parmetros:  nenhum
'*  Retorno...:  0 caso der certo ou ou codigo de erro negativo
'*               -1 = Saiu por TimeOut
'*               -2 = Porta no Abriu
'*               -3 = Porta no fechou
'*               -4 = Porta j est aberta
'*               -5 = No retornou o 92, checksum
'****************************************************************
Public Function Reset2() As Integer

    Dim iRetorno As Integer
    Dim Instring As String
    Dim t1, t2
    
    On Error Resume Next
    Comm1.CommPort = Porta
    If Err <> 0 Then iRetorno = -4: GoTo fimfuncao
    On Error GoTo 0
    
    Comm1.Settings = "9600,N,8,1"
    Comm1.InputLen = 0
    Comm1.InBufferSize = 10
    
    On Error Resume Next
    Comm1.PortOpen = True
    If Err <> 0 Then iRetorno = -2: GoTo fimfuncao
    On Error GoTo 0
    
    Comm1.Output = Chr(5) & "QE" & Chr(6) & Chr(6)
    Instring = ""
    
    t1 = Now
    t2 = DateAdd("s", TimeOut, t1)
    iRetorno = 0
    
    Do
         DoEvents
         If Now >= t2 Then
            iRetorno = -1
            Exit Do
         End If
         
    Loop Until Comm1.InBufferCount >= 1
    
    Instring = Instring & Comm1.Input
    
    On Error Resume Next
    Comm1.PortOpen = False
    If Err <> 0 Then iRetorno = -3: GoTo fimfuncao
    On Error GoTo 0
    
    If iRetorno = -1 Then GoTo fimfuncao
    
    If Trim(Instring) = "" Then
       iRetorno = -5
    Else
       iRetorno = Asc(Right(Instring, 1))
       If iRetorno = 105 Then
          iRetorno = 0
       Else
          iRetorno = -5
       End If
    End If
    
fimfuncao:
    
    Reset2 = iRetorno
    
End Function
'****************************************************************
'*  Funo....:  Show ( a )
'*  Descricao.:  Mostra uma figura na cmera
'*  Parmetros:  a -> Numero da figura a ser mostrada
'*  Retorno...:  0 caso der certo ou ou codigo de erro negativo
'*               -1 = Saiu por TimeOut
'*               -2 = Porta no Abriu
'*               -3 = Porta no fechou
'*               -4 = Porta j est aberta
'*               -5 = No retornou o checksum
'****************************************************************
Public Function Show(iPicture As Integer) As Integer

    Dim iRetorno As Integer
    Dim Instring As String
    Dim t1, t2
    
    On Error Resume Next
    Comm1.CommPort = Porta
    If Err <> 0 Then iRetorno = -4: GoTo fimfuncao
    On Error GoTo 0
    
    Comm1.Settings = "9600,N,8,1"
    Comm1.InputLen = 0
    Comm1.InBufferSize = 10
    
    On Error Resume Next
    Comm1.PortOpen = True
    If Err <> 0 Then iRetorno = -2: GoTo fimfuncao
    On Error GoTo 0
    
    Comm1.Output = Chr(5) & "DA" & Chr(iPicture) & Chr(6) & Chr(6)
    Instring = ""
    
    t1 = Now
    t2 = DateAdd("s", TimeOut, t1)
    iRetorno = 0
    
    Do
         DoEvents
         If Now >= t2 Then
            iRetorno = -1
            Exit Do
         End If
         
    Loop Until Comm1.InBufferCount >= 1
    
    Instring = Instring & Comm1.Input
    
    On Error Resume Next
    Comm1.PortOpen = False
    If Err <> 0 Then iRetorno = -3: GoTo fimfuncao
    On Error GoTo 0
    
    If iRetorno = -1 Then GoTo fimfuncao
    
    If Trim(Instring) = "" Then
       iRetorno = -5
    Else
       iRetorno = Asc(Right(Instring, 1))
       If iRetorno = (122 - iPicture) Then
          iRetorno = 0
       Else
          iRetorno = -5
       End If
    End If
    
fimfuncao:
    
    Show = iRetorno
    
End Function

'****************************************************************
'*  Funo....:  Delete ( a )
'*  Descricao.:  Apaga uma figura na cmera
'*  Parmetros:  a -> Numero da figura a ser apagada
'*  Retorno...:  0 caso der certo ou ou codigo de erro negativo
'*               -1 = Saiu por TimeOut
'*               -2 = Porta no Abriu
'*               -3 = Porta no fechou
'*               -4 = Porta j est aberta
'*               -5 = No retornou o checksum
'****************************************************************
Public Function Delete(iPicture As Integer) As Integer

    Dim iRetorno As Integer
    Dim Instring As String
    Dim t1, t2
    
    On Error Resume Next
    Comm1.CommPort = Porta
    If Err <> 0 Then iRetorno = -4: GoTo fimfuncao
    On Error GoTo 0
    
    Comm1.Settings = "9600,N,8,1"
    Comm1.InputLen = 0
    Comm1.InBufferSize = 10
    
    On Error Resume Next
    Comm1.PortOpen = True
    If Err <> 0 Then iRetorno = -2: GoTo fimfuncao
    On Error GoTo 0
    
    Comm1.Output = Chr(5) & "DF" & Chr(iPicture) & Chr(255) & Chr(6) & Chr(6)
    Instring = ""
    
    t1 = Now
    t2 = DateAdd("s", TimeOut, t1)
    iRetorno = 0
    
    Do
         DoEvents
         If Now >= t2 Then
            iRetorno = -1
            Exit Do
         End If
         
    Loop Until Comm1.InBufferCount >= 1
    
    Instring = Instring & Comm1.Input
    
    On Error Resume Next
    Comm1.PortOpen = False
    If Err <> 0 Then iRetorno = -3: GoTo fimfuncao
    On Error GoTo 0
    
    If iRetorno = -1 Then GoTo fimfuncao
    
    If Trim(Instring) = "" Then
       iRetorno = -5
    Else
       iRetorno = Asc(Right(Instring, 1))
       If iRetorno = (118 - iPicture) Then
          iRetorno = 0
       Else
          iRetorno = -5
       End If
    End If
    
fimfuncao:
    
    Delete = iRetorno
    
End Function


'****************************************************************
'*  Funo....:  Take
'*  Descricao.:  Tira uma foto
'*  Parmetros:  Nenhum
'*  Retorno...:  0 caso der certo ou ou codigo de erro negativo
'*               -1 = Saiu por TimeOut
'*               -2 = Porta no Abriu
'*               -3 = Porta no fechou
'*               -4 = Porta j est aberta
'*               -5 = No retornou o checksum
'****************************************************************
Public Function Take() As Integer

    Dim iRetorno As Integer
    Dim Instring As String
    Dim t1, t2
    
    On Error Resume Next
    Comm1.CommPort = Porta
    If Err <> 0 Then iRetorno = -4: GoTo fimfuncao
    On Error GoTo 0
    
    Comm1.Settings = "9600,N,8,1"
    Comm1.InputLen = 0
    Comm1.InBufferSize = 10
    
    On Error Resume Next
    Comm1.PortOpen = True
    If Err <> 0 Then iRetorno = -2: GoTo fimfuncao
    On Error GoTo 0
    
    Comm1.Output = Chr(5) & "DR" & Chr(6) & Chr(6) & Chr(105)
    Instring = ""
    
    t1 = Now
    t2 = DateAdd("s", TimeOut, t1)
    iRetorno = 0
    
    Do
         DoEvents
         If Now >= t2 Then
            iRetorno = -1
            Exit Do
         End If
         
    Loop Until Comm1.InBufferCount >= 1
    
    Instring = Instring & Comm1.Input
    
    On Error Resume Next
    Comm1.PortOpen = False
    If Err <> 0 Then iRetorno = -3: GoTo fimfuncao
    On Error GoTo 0
    
    If iRetorno = -1 Then GoTo fimfuncao
    
    If Trim(Instring) = "" Then
       iRetorno = -5
    Else
       iRetorno = Asc(Right(Instring, 1))
       If iRetorno = 105 Then
          iRetorno = 0
       Else
          iRetorno = -5
       End If
    End If
    
fimfuncao:
    
    Take = iRetorno
    
End Function

'****************************************************************
'*  Funo....:  Order ( a , b )
'*  Descricao.:  Muda a ordem de 2 figuras
'*  Parmetros:  a -> Figura Origem
'*               b -> Figura Destino
'*  Retorno...:  0 caso der certo ou ou codigo de erro negativo
'*               -1 = Saiu por TimeOut
'*               -2 = Porta no Abriu
'*               -3 = Porta no fechou
'*               -4 = Porta j est aberta
'*               -5 = No retornou o checksum
'****************************************************************
Public Function Order(iOrigem As Integer, iDestino As Integer) As Integer

    Dim iRetorno As Integer
    Dim Instring As String
    Dim t1, t2
    
    On Error Resume Next
    Comm1.CommPort = Porta
    If Err <> 0 Then iRetorno = -4: GoTo fimfuncao
    On Error GoTo 0
    
    Comm1.Settings = "9600,N,8,1"
    Comm1.InputLen = 0
    Comm1.InBufferSize = 10
    
    On Error Resume Next
    Comm1.PortOpen = True
    If Err <> 0 Then iRetorno = -2: GoTo fimfuncao
    On Error GoTo 0
    
    Comm1.Output = Chr(5) & "DI" & Chr(iOrigem) & Chr(6) & _
                   Chr(5) & "DY" & Chr(2) & Chr(iOrigem) & Chr(6) & _
                   Chr(5) & "DF" & Chr(iOrigem) & Chr(255) & Chr(6) & _
                   Chr(5) & "Dj" & Chr(iDestino) & Chr(6) & Chr(6)

    Instring = ""
    
    t1 = Now
    t2 = DateAdd("s", TimeOut, t1)
    iRetorno = 0
    
    Do
         DoEvents
         If Now >= t2 Then
            iRetorno = -1
            Exit Do
         End If
         
    Loop Until Comm1.InBufferCount >= 1
    
    Instring = Instring & Comm1.Input
    
    On Error Resume Next
    Comm1.PortOpen = False
    If Err <> 0 Then iRetorno = -3: GoTo fimfuncao
    On Error GoTo 0
    
    If iRetorno = -1 Then GoTo fimfuncao
    
    If Trim(Instring) = "" Then
       iRetorno = -5
    Else
       iRetorno = Asc(Right(Instring, 1))
       If iRetorno = 114 - iOrigem Then
          iRetorno = 0
       Else
          iRetorno = -5
       End If
    End If
    
fimfuncao:
    
    Order = iRetorno
    
End Function
'****************************************************************
'*  Funo....:  DisableAutoPowerOff
'*  Descricao.:  Liga/Desliga Modo de desligamento automtico
'*  Parmetros:  Nenhum
'*  Retorno...:  0 caso der certo ou ou codigo de erro negativo
'*               -1 = Saiu por TimeOut
'*               -2 = Porta no Abriu
'*               -3 = Porta no fechou
'*               -4 = Porta j est aberta
'*               -5 = No retornou o checksum
'****************************************************************
Public Function DisableAutoPowerOff() As Integer

    Dim iRetorno As Integer
    Dim Instring As String
    Dim t1, t2
    
    On Error Resume Next
    Comm1.CommPort = Porta
    If Err <> 0 Then iRetorno = -4: GoTo fimfuncao
    On Error GoTo 0
    
    Comm1.Settings = "9600,N,8,1"
    Comm1.InputLen = 0
    Comm1.InBufferSize = 10
    
    On Error Resume Next
    Comm1.PortOpen = True
    If Err <> 0 Then iRetorno = -2: GoTo fimfuncao
    On Error GoTo 0
    
    Comm1.Output = Chr(5) & "DU" & Chr(6) & Chr(5) & "QE" & Chr(6) & Chr(6)

    Instring = ""
    
    t1 = Now
    t2 = DateAdd("s", TimeOut, t1)
    iRetorno = 0
    
    Do
         DoEvents
         If Now >= t2 Then
            iRetorno = -1
            Exit Do
         End If
         
    Loop Until Comm1.InBufferCount >= 1
    
    Instring = Instring & Comm1.Input
    
    On Error Resume Next
    Comm1.PortOpen = False
    If Err <> 0 Then iRetorno = -3: GoTo fimfuncao
    On Error GoTo 0
    
    If iRetorno = -1 Then GoTo fimfuncao
    
    If Trim(Instring) = "" Then
       iRetorno = -5
    Else
       iRetorno = Asc(Right(Instring, 1))
       If iRetorno = 105 Then
          iRetorno = 0
       Else
          iRetorno = -5
       End If
    End If
    
fimfuncao:
    
    DisableAutoPowerOff = iRetorno
    
End Function


'****************************************************************
'*  Funo....:  SaveJpg
'*  Descricao.:
'*  Parmetros:  a ->
'*  Retorno...:  0 caso der certo ou ou codigo de erro negativo
'*               -1 = Saiu por TimeOut
'*               -2 = Porta no Abriu
'*               -3 = Porta no fechou
'*               -4 = Porta j est aberta
'*               -5 = No retornou o checksum
'****************************************************************
Public Function SaveJpg(iNum As Integer) As Integer

    Dim iRetorno As Integer
    Dim Instring As String
    Dim t1, t2
    
    On Error Resume Next
    Comm1.CommPort = Porta
    If Err <> 0 Then iRetorno = -4: GoTo fimfuncao
    On Error GoTo 0
    
    Comm1.Settings = "9600,N,8,1"
    Comm1.InputLen = 0
    Comm1.InBufferSize = 10
    
    On Error Resume Next
    Comm1.PortOpen = True
    If Err <> 0 Then iRetorno = -2: GoTo fimfuncao
    On Error GoTo 0
    
    Comm1.Output = Chr(5) & "DA" & Chr(iNum) & _
                   Chr(6) & Chr(5) & "DL" & Chr(6) & Chr(5) & _
                   "MG" & Chr(6) & Chr(18) & Chr(6) & Chr(6)

    Instring = ""
    
    t1 = Now
    t2 = DateAdd("s", TimeOut, t1)
    iRetorno = 0
    
    Do
         DoEvents
         If Now >= t2 Then
            iRetorno = -1
            Exit Do
         End If
         
    Loop Until Comm1.InBufferCount >= 1
    
    Instring = Instring & Comm1.Input
    
    On Error Resume Next
    Comm1.PortOpen = False
    If Err <> 0 Then iRetorno = -3: GoTo fimfuncao
    On Error GoTo 0
    
    If iRetorno = -1 Then GoTo fimfuncao
    
    If Trim(Instring) = "" Then
       iRetorno = -5
    Else
       iRetorno = Asc(Right(Instring, 1))
       If iRetorno = 105 Then
          iRetorno = 0
       Else
          iRetorno = -5
       End If
    End If
    
fimfuncao:
    
    SaveJpg = iRetorno
    
End Function


